platform :ios do
  desc "Build and sign the application for development"
  lane :ios_components_build do
    # Detect if we are running in CI, and create a temporary keychain
    # and switch match to readonly mode
    # https://docs.fastlane.tools/actions/setup_ci/
    setup_ci

    # Download and install the correct signing certificates for the 
    # given build environment, in this case development
    # https://docs.fastlane.tools/actions/match/
    match(
      type: "<%= destination %>", 
      readonly: true,
      storage_mode: "gitlab_secure_files",
      app_identifier: "<%= app_identifier %>"
    )

    # Login to App Store Connect in order to perform actions later
    # in this process. Configuration provided by environment variables added
    # by the GitLab Apple Apps Store integration 
    # https://docs.gitlab.com/ee/user/project/integrations/apple_app_store.html
    # https://docs.fastlane.tools/actions/app_store_connect_api_key/
    app_store_connect_api_key(
      is_key_content_base64: true
    )

    # Auto increment the build number for Test Flight
    # https://docs.fastlane.tools/actions/increment_build_number/
    # https://docs.fastlane.tools/actions/latest_testflight_build_number/
    increment_build_number(
      build_number: latest_testflight_build_number(
        app_identifier: "<%= app_identifier %>",
        initial_build_number: 1
      ) + 1,
      xcodeproj: "<%= project_name %>"
    )

    # Build the app with the supplied configuration settings
    # Export method is the same as the match step above
    # https://docs.fastlane.tools/actions/build_app/
    build_app(
      project: "<%= project_name %>",
      scheme: "<%= build_schema %>",
      configuration: "<%= build_configuration %>",
      export_method: "<%= export_method %>",
      output_directory: "<%= output_directory %>",
      output_name: "<%= output_name %>"
    )
  end
end
